## ceph 13.2.4+dfsg1

=== debian/changelog ===
ceph (13.2.4+dfsg1-0ubuntu0.18.10.2) cosmic-security; urgency=medium

  * SECURITY UPDATE: encryption key leak in log
    - debian/patches/CVE-2018-16889.patch: sanitize customer encryption
      keys from log output in src/rgw/rgw_auth_s3.cc,
      src/rgw/rgw_rest_s3.cc.
    - CVE-2018-16889
  * SECURITY UPDATE: civetweb file descriptor leak
    - debian/patches/CVE-2019-3821.patch: properly close connection in
      src/civetweb/src/civetweb.c.
    - CVE-2019-3821

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 29 May 2019 11:11:40 -0400

ceph (13.2.4+dfsg1-0ubuntu0.18.10.1) cosmic; urgency=medium

  * New upstream point release (LP: #1810766).

 -- James Page <james.page@ubuntu.com>  Tue, 29 Jan 2019 14:43:15 +0000

ceph (13.2.1+dfsg1-0ubuntu2.18.10.1) cosmic; urgency=medium

  * Re-introduce Ceph Mimic to Ubuntu Cosmic (LP: #1805355).
  * d/p/misc-32-bit-fixes.patch: Update type of rgw_max_attr_name_len,
    resolving SIGABRT in radosgw (LP: #1805145).

 -- James Page <james.page@ubuntu.com>  Wed, 28 Nov 2018 10:35:58 +0000

ceph (13.2.1+dfsg1-0ubuntu2) cosmic; urgency=medium

  * d/ceph-mds.install: Install missing systemd configuration
    (LP: #1789927).

 -- James Page <james.page@ubuntu.com>  Thu, 30 Aug 2018 16:07:10 +0100

ceph (13.2.1+dfsg1-0ubuntu1) cosmic; urgency=medium

  * Re-instate 32bit architectures.
    - d/control: Switch back to linux-any
    - d/p/misc-32-bit-fixes.patch: Misc fixes for compilation
      failures under 32 bit architectures.
    - d/rules: Disable SPDK integration under i386.
  * Repack upstream tarball, excluding non-DFSG sources (LP: #1750848):
    - d/copyright: Purge upstream tarball of minified js files, which
      are neither shipped in binaries or required for package build.
    - d/watch: Add dversionmangle for +dfsg\d version suffix.
  * d/control,rules: Drop requirement for gcc-7 for arm64.
  * d/ceph-osd.udev: Add udev rules for sample LVM layout for OSD's,
    ensuring that LV's have ceph:ceph ownership (LP: #1767087).

 -- James Page <james.page@ubuntu.com>  Thu, 09 Aug 2018 14:20:08 +0100

ceph (13.2.1-0ubuntu1) cosmic; urgency=medium

  * d/copyright,source.lintian-overrides: Exclude jsonchecker component
    of rapidjson avoiding license-problem-json-evil non-free issue.
  * New upstream point release.
  * d/control: Remove obsolete X{S}-* fields.

 -- James Page <james.page@ubuntu.com>  Wed, 01 Aug 2018 11:13:12 +0100

ceph (13.2.0-0ubuntu1) cosmic; urgency=medium

  * New upstream release.
  * Sync with changes in upstream packaging:
    - d/*.install,rules: Use generated systemd unit files for install
    - d/ceph-test.install: Drop binaries removed upstream.
  * d/p/*: Refresh and drop as needed.
  * d/*.symbols: Refresh for new release.
  * d/rules,calc-max-parallel.sh: Automatically calculate the maximum
    number of parallel compilation units based on total memory.
  * d/control: Drop support for 32 bit architectures.
  * d/control: Update Vcs-* fields for Ubuntu.
  * d/control: Drop min python version field.

 -- James Page <james.page@ubuntu.com>  Tue, 24 Jul 2018 11:01:39 +0100
